<template>
  <div id="main">
    <c-header></c-header>
    <c-sidebar></c-sidebar>

    <router-view></router-view>
    <notifications group="chat-notif" classes="custom-notification shadow-sm rounded"/>
    <notifications group="notif" classes="vue-notification shadow-sm bg-primary info-notification" position="top center"/>
    <notifications group="error" classes="vue-notification shadow-sm" position="top center"/>

    <lenna-loading v-show="isLoading"></lenna-loading>
    <menu-modal :show="showMenuModal"></menu-modal>
    <button class="btn menu-button d-block d-sm-none" @click="showMenuModal">
        <img :src="asset('images/ui_elements/ic_list_grey.svg')" width="15px">

    </button>

  </div>
</template>

<script>
import moment from "moment";
import Header from "./Header";
import Sidebar from "./sidebar/Sidebar";
import NotificationHelper from "@/helpers/NotificationHelper"
import MenuModal from "@/components/general/MenuModal";
import EventBus from "@/EventBus.js";

export default {
  name: "main-app",
  components: {
    "c-header": Header,
    "c-sidebar": Sidebar,
    "menu-modal":MenuModal
  },
  computed: {
    isLoading() {
      return this.$store.getters["general/isLoading"];
    },
    isSidebarOpen() {
      return this.$store.state.isSidebarOpen;
    },
    selectedRoom() {
      return this.$store.getters["chat/selectedRoom"];
    }
  },
  beforeCreate(){
      this.$store.dispatch("app/getAppData")
  },
  created() {
    window.onresize = () => {
        this.$store.commit("UPDATE_WIDTH")
    }
    
    let Notification = new NotificationHelper({vm:this})

    this.$socket.on(`connect`, function(data) {
      console.log("connected to socket");
    });
    this.$echo.channel("testChannel").listen("TestEvent", data => {
      console.log("connected from: ", data);
    });
    this.$echo
      .private("ChannelApp." + this.$store.getters.appId.decoded)
      .listen("RequestLive",data=>{
         Notification.show({...data,notificationType:"live-request"})
        this.$store.dispatch("chat/liveChatRequest", data);
      })
      .listen("NewMessage", data => {
        Notification.show({...data,notificationType:"chat-message"})
        this.$store.dispatch("chat/newMessage", data);
      });

    this.$echo
      .private("ChannelApp." + this.$store.getters.appId.decoded)
      .listen(`NewUser`, data => {});
  },
  methods:{
      showMenuModal(){
               EventBus.$emit("showMenuModal");

     }
  }
};
</script>
<style lang="scss">
.main-content-wrap {
  padding: 0 !important;
}
.info-notification{
  border-left: 5px solid white;

}
.menu-button{
    position: fixed;
    bottom: 0;
    left: 0;
}
</style>
